if(ForceRequiredAddon("Weapon_SWeps") == $Error::AddOn_NotFound)
	return;
	
AddDamageType("Sniper",'<bitmap:Add-Ons/Weapon_SWeps_WSniper/model/icon/ci_sniper> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_WSniper/model/icon/ci_sniper> %1',0.2,1);
AddDamageType("SniperHeadshot",'<bitmap:Add-Ons/Weapon_SWeps_WSniper/model/icon/ci_sniper> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_WSniper/model/icon/ci_sniper><bitmap:Add-Ons/Weapon_SWeps_WSniper/model/icon/ci_headshot> %1',0.2,1);

swolammo_addAmmoType("308","Sniper Rounds",5*3,5);

datablock ItemData(ammoBox308ItemA : ammoBox9mmItemA)
{
	shapeFile = "./model/ammobox_308A.dts";
	iconName = "./model/icon/icon_ammo308";
	uiName = "Ammo Sniper";
	colorShiftColor = "0.9 0.9 0.9 1";
	sAmmo = 10;
	sAmmoType = "308";
};
datablock ItemData(ammoBox308ItemB : ammoBox9mmItemA)
{
	shapeFile = "./model/ammobox_308B.dts";
	uiName = "Ammo Sniper B";
	colorShiftColor = "0.9 0.9 0.9 1";
	sAmmo = 10;
	sAmmoType = "308";
};


datablock StaticShapeData(swol_bulletTrailStatic)
{
	shapeFile = "./model/sniperTrail.dts";
};
datablock StaticShapeData(swol_sniperLensStatic)
{
	shapeFile = "./model/sniperflare.dts";
};
function swol_bulletTrailStatic::onAdd(%db,%obj)
{
	%obj.playThread(0,root);
	%obj.schedule(150,delete);
}

datablock explosionData(sniperExplosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
};
datablock ProjectileData(sniperFakeEmptyProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	uiName 					= "";
	muzzleVelocity 			= 200;
	armingDelay = 1023;
};
datablock ProjectileData(sniperProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 50;
	headShotDamage 			= 250;
	explosion 				= sniperExplosion;
	directDamageType    	= $DamageType::Sniper;
	headShotDamageType		= $DamageType::SniperHeadshot;
	radiusDamageType    	= $DamageType::Sniper;
	particleEmitter     	= sWepBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	bulletWizzRadius = 10;
	sProjectile = 1;
};
function sniperProjectile::onCollision(%db,%proj,%hit,%vec,%vel)
{
	if(!isObject(%proj.fakeProj))
		return parent::onCollision(%db,%proj,%hit,%vec,%vel);
	%p = new StaticShape() 
	{ 
		dataBlock = swol_bulletTrailStatic;
	};
	%p.setNodeColor("ALL","1 0.2 0 1");
	missionCleanup.add(%p);
	%velocity = vectorScale(VectorNormalize(%proj.initialVelocity),-1);
	%x = getWord(%velocity,0)/2;
	%y = (getWord(%velocity,1) + 1)/2;
	%z = getWord(%velocity,2)/2;
	%p.setTransform(%proj.getPosition() SPC VectorNormalize(%x SPC %y SPC %z) SPC mDegToRad(180));
	%scale = 2;
	%dist = vectorDist(%proj.getPosition(),%proj.fakeProj.getPosition());
	%p.setScale(%scale SPC %dist SPC %scale);
	%proj.fakeProj.delete();
	parent::onCollision(%db,%proj,%hit,%vec,%vel);
}
function sniperProjectile::damage(%db,%proj,%hit,%fade,%pos,%normal)
{
	parent::damage(%db,%proj,%hit,%fade,%pos,%normal);
}
datablock AudioProfile(sniperFire1Sound)
{
	filename    = "./sound/sniper_fire1.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(sniperFire2Sound : sniperFire1Sound)
{
	filename    = "./sound/sniper_fire2.wav";
};
datablock AudioProfile(sniperBoltOpenSound : sniperFire1Sound)
{
	filename    = "./sound/sniper_boltOpen.wav";
};
datablock AudioProfile(sniperBoltCloseSound : sniperFire1Sound)
{
	filename    = "./sound/sniper_boltClose.wav";
};
datablock AudioProfile(sniperLoadSound : sniperFire1Sound)
{
	filename    = "./sound/sniper_load1.wav";
	description = AudioClose3D;
};
datablock AudioDescription(bulletWizzSound : AudioDefault3D)
{
	maxDistance = 60;
	referenceDistance = 1;
};
datablock AudioProfile(sniperMiss1Sound : sniperFire1Sound)
{
	filename    = "./sound/sniper_miss1.wav";
	description = bulletWizzSound;
};
datablock AudioProfile(sniperMiss2Sound : sniperFire1Sound)
{
	filename    = "./sound/sniper_miss2.wav";
	description = bulletWizzSound;
};
datablock AudioProfile(sniperMiss3Sound : sniperFire1Sound)
{
	filename    = "./sound/sniper_miss3.wav";
	description = bulletWizzSound;
};
datablock AudioProfile(sniperMiss4Sound : sniperFire1Sound)
{
	filename    = "./sound/sniper_miss4.wav";
	description = bulletWizzSound;
};
datablock AudioProfile(sniperScopeInSound : sniperFire1Sound)
{
	filename    = "./sound/sniper_scopeIn.wav";
	description = AudioClose3D;
};
datablock AudioProfile(sniperScopeOutSound : sniperFire1Sound)
{
	filename    = "./sound/sniper_scopeOut.wav";
	description = AudioClose3D;
};
datablock AudioProfile(sniperDistant1Sound : sniperFire1Sound)
{
	filename    = "./sound/sniper_distant1.wav";
	description = Audio2D;
};
datablock AudioProfile(sniperDistant2Sound : sniperFire1Sound)
{
	filename    = "./sound/sniper_distant2.wav";
	description = Audio2D;
};
datablock AudioProfile(sniperReverbSound : sniperFire1Sound)
{
	filename    = "./sound/sniper_reverb.wav";
	description = Audio2D;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(sniperIcon)
	{
		uiName = "Sniper";
		iconName = "./model/icon/icon_sniper";
	};
}
datablock ItemData(sniperItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/sniper.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Wasteland Sniper";
	iconName = "./model/icon/icon_sniper";
	fakeIcon = sniperIcon;
	doColorShift = true;
	colorShiftColor = "0.33 0.63 0.33 1";
	colorShiftColor = "0.566929 0.346457 0.196850 1.000000";
	ammo = 1;

	image = sniperImage;
	scopedImage = sniperScopeImage;
	unScopingImage = sniperUnScopeImage;
	scopedZoom = 0.7;
	scopedSpeed = 0.2;
	
	canDrop = true;
	isLargeWeapon = 1;
	
	sAmmoType = "308";
	sAmmo = 5;
	sHeat = 30;
	sAmmoShellReload = 1;
};
datablock ShapeBaseImageData(sniperScopeImage)
{
	className = "WeaponImage";
	shapeFile = "./model/sniper.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.09 0.12";
	eyeOffset = "0 0.15 -0.365";
	eyeRotation = "0 0 0";
	//eyeOffset = "0 2 0";
	//eyeRotation = "0 0 1 90";
	item = sniperItem;
	ammo = " ";
	projectile = sniperProjectile;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	isScoped = 1;
	
	
	doColorShift = true;
	colorShiftColor = "0.566929 0.346457 0.196850 1.000000";
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "scope";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Release";
	
	stateName[1]					= "Release";
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTriggerUp[1]	= "Idle";
	
	stateName[2]					= "Idle";
	stateScript[2]					= "onIdle";
	stateTransitionOnTriggerDown[2]	= "Trigger";
	
	stateName[3]					= "Trigger";
	stateSequence[3]				= "trig";
	stateScript[3]					= "onTrigger";
	stateTimeoutValue[3]			= 0.06;
	stateSound[3]					= mac10TrigSound;
	stateTransitionOnTimeout[3] 	= "FireCheckA";
	
	stateName[4]					= "FireCheckA";
	stateScript[4]					= "onFireCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "FireCheckB";
	
	stateName[5]					= "FireCheckB";
	stateTransitionOnAmmo[5]		= "Fire";
	stateTransitionOnNoAmmo[5]		= "DryFire";
	
	stateName[6]					= "DryFire";
	stateTransitionOnTimeout[6]		= "Untrig";
	stateScript[6]					= "onDryFire";
	stateTimeoutValue[6]			= 0.2;
	
	stateName[7]					= "Fire";
	stateTimeoutValue[7]			= 0.2;
	stateSequence[7]				= "fire";
	stateEmitter[7]					= gunFlashEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzlePoint";
	stateScript[7]					= "onFire";
	stateTransitionOnTimeout[7]		= "Smoke";
	stateFire[7]					= true;
	
	stateName[8]					= "Smoke";
	stateTimeoutValue[8]			= 0.1;
	stateEmitter[8]					= gunSmokeEmitter;
	stateEmitterTime[8]				= 0.05;
	stateEmitterNode[8]				= "muzzlePoint";
	stateTransitionOnTimeout[8]		= "Bolt";
	
	stateName[9]					= "Bolt";
	stateSequence[9]				= "pull";
	stateTimeoutValue[9]			= 0.6;
	stateTransitionOnTimeout[9]		= "Eject";
	stateScript[9]					= "onBoltPull";
	
	stateName[10]					= "Eject";
	stateEjectShell[10]				= true;
	stateSequence[10]				= "eject";
	stateScript[10]					= "onEject";
	stateTimeoutValue[10]			= 0.35;
	stateTransitionOnTimeout[10]	= "Wait";
	
	stateName[11]					= "Wait";
	stateTimeoutValue[11]			= 0.4;
	stateTransitionOnTimeout[11]	= "Release";
	
	stateName[12]					= "Untrig";
	stateSequence[12]				= "untrig";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]	= "Release";
};
function sniperScopeImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function sniperScopeImage::onDryFire(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	%pl.sAmmo_warn = "warn";
	%pl.sAmmo_warnMax = 150;
	%pl.sAmmo_lastWarn = getSimTime();
	sAmmo_display(%pl);
}
function sniperScopeImage::onEject(%db,%pl,%slot)
{
	%pl.playThread(2,shiftRight);
	%pl.playAudio(2,sniperBoltCloseSound);
}
function sniperScopeImage::onBoltPull(%db,%pl,%slot)
{
	%pl.playAudio(2,sniperBoltOpenSound);
}
function sniperScopeImage::onFire(%db,%pl,%slot)
{
	sAmmo_sniperRaycast(%pl,%slot);
	//serverPlay3D(sniperFire @ getRandom(1,2) @ Sound,%pl.getPosition());
	%pl.playAudio(1,sniperFire @ getRandom(1,2) @ Sound);
	//%p = sAmmo_fire(%db,%pl,%slot,0.1*(%pl.sAmmo_heat[%db]/%db.item.sHeat)+(vectorDist(%pl.getVelocity(),"0 0 0")*0.002),800,1);
	//%p = sAmmo_fire(%db,%pl,%slot,0.1*(%pl.sAmmo_heat[%db]/%db.item.sHeat),1800,1);
	//%pl.sAmmo_heat[%db] = %db.item.sHeat;
	//cancel(%pl.sAmmoCooldownHeatSched[%db]);
	//%pl.sAmmoCooldownHeatSched[%db] = %pl.schedule(200,sAmmo_heatCooldown,%db,%slot);
	
	%val = sAmmo_dec(%db,%pl,%slot);
	%pl.playThread(2,plant);
	
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
		
	%pl.disableCmdSwap = 1;
	%pl.schedule(3800,sniperSafetyFix);
}
function player::sniperSafetyFix(%pl)
{
	cancel(%pl.sniperSafetyFix);
	%pl.disableCmdSwap = 0;
	%pl.delayedCmdSwap();
}
function sniperScopeImage::onIdle(%db,%pl,%slot)
{
	cancel(%pl.sniperSafetyFix);
	%pl.disableCmdSwap = 0;
	%pl.delayedCmdSwap();
}
datablock ShapeBaseImageData(sniperUnScopeImage)
{
	className = "WeaponImage";
	shapeFile = "./model/sniper.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.09 0.12";
	eyeOffset = "0 0.15 -0.365";
	eyeRotation = "0 0 0";
	//eyeOffset = "0 2 0";
	//eyeRotation = "0 0 1 90";
	item = sniperItem;
	ammo = " ";
	projectile = sniperProjectile;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	isScoped = 0;
	
	
	doColorShift = true;
	colorShiftColor = "0.566929 0.346457 0.196850 1.000000";
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "scope";
	stateTimeoutValue[0]			= 0.3;
	stateDirection[0]				= 0;
	stateTransitionOnTimeout[0] 	= "Done";
	
	stateName[1]					= "Done";
	stateScript[1]					= "onDone";
};
function sniperUnScopeImage::onDone(%db,%pl,%slot)
{
	%pl.mountImage(sniperImage,%slot);
}
datablock ShapeBaseImageData(sniperImage)
{
	className = "WeaponImage";
	shapeFile = "./model/sniper.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.09 0.12";
	eyeOffset = "0.55 0.75 -0.45";
	eyeRotation = "0 0 0";
	//eyeOffset = "0 2 0";
	//eyeRotation = "0 0 1 90";
	item = sniperItem;
	ammo = " ";
	projectile = sniperProjectile;
	projectileType = Projectile;
	
	casing = revolverShellDebris;
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	isScoped = 0;
	
	
	doColorShift = true;
	colorShiftColor = "0.566929 0.346457 0.196850 1.000000";
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Release";
	
	stateName[1]					= "Release";
	stateSequence[1]				= "root";
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTriggerUp[1]	= "Idle";
	
	stateName[2]					= "Idle";
	stateTransitionOnNotLoaded[2]	= "StartLoading";
	
	stateName[3]					= "StopLoading";
	stateDirection[3]				= 0;
	stateSequence[3]				= "loadPos";
	stateScript[3]					= "onStopLoading";
	stateTimeoutValue[3]			= 0.26;
	stateTransitionOnTimeout[3]	= "Idle";
	
	stateName[4]					= "StartLoading";
	stateSequence[4]				= "loadPos";
	stateScript[4]					= "onStartLoading";
	stateTimeoutValue[4]			= 0.26;
	stateTransitionOnTimeout[4]	= "LoadCheckA";
	
	stateName[5]					= "LoadCheckA";
	stateScript[5]					= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]	= "LoadA";
	
	stateName[6]					= "LoadCheckB";
	stateTransitionOnLoaded[6]		= "StopLoading";
	stateTransitionOnNotLoaded[6]		= "LoadCheckA";
	
	stateName[7]					= "LoadA";
	stateScript[7]					= "onLoad";
	stateTimeoutValue[7]			= 0.15;
	stateSequence[7]				= "load";
	stateTransitionOnTimeout[7]	= "LoadB";
	
	stateName[8]					= "LoadB";
	stateTimeoutValue[8]			= 0.1;
	stateTransitionOnTriggerDown[8] = "StopLoading";
	stateTransitionOnTimeout[8]	= "LoadC";
	
	stateName[9]					= "LoadC";
	stateTransitionOnTriggerDown[9]	= "StopLoading";
	stateTimeoutValue[9]			= 0.12;
	stateTransitionOnTimeout[9]		= "LoadCheckB";
	
};
function sniperImage::onStartLoading(%db,%pl,%slot)
{
	%pl.playThread(2,shiftRight);
	%pl.setImageLoaded(%slot,0);
}
function sniperImage::onStopLoading(%db,%pl,%slot)
{
	%pl.playThread(2,shiftLeft);
	%pl.setImageLoaded(%slot,1);
	if(sAmmo_check(%db,%pl,%slot) > 0)
		%pl.setImageAmmo(%slot,1);
}
function sniperImage::onLoadCheck(%db,%pl,%slot)
{
	if(sAmmo_check(%db,%pl,%slot) < %db.item.sAmmo-1)
	{
		if(($Pref::Swol_ReserveAmmo == 1 && sAmmo_rCheck(%db,%pl,%slot) <= 1))
		{
			%pl.setImageLoaded(%slot,1);
		}
		else
		{
			%pl.setImageLoaded(%slot,0);
		}
	}
	else
	{
		%pl.setImageLoaded(%slot,1);
	}
}
function sniperImage::onLoad(%db,%pl,%slot)
{
	serverPlay3D(sniperLoadSound,%pl.getPosition());
	%pl.playThread(2,plant);
	if(sAmmo_rCheck(%db,%pl,%slot) > 0 && sAmmo_check(%db,%pl,%slot) < %db.item.sAmmo)
	{
		sAmmo_rDec(%db,%pl,%slot);
		sAmmo_load(%db,%pl,%slot,sAmmo_check(%db,%pl,%slot)+1);
	}
}


function sniperScopeImage::onMount(%db,%pl,%slot)
{
	if(isEventPending(%pl.sniperCleanUpSched))
	{
		cancel(%pl.sniperCleanUpSched);
	}
	else
	{
		if($Swol_GhostDLL || ($Swol_GhostDLL = isFunction("NetObject","setNetFlag")))
			%pl.sniperLensLoopStart();
	}
	parent::onMount(%db,%pl,%slot);
}
function sniperScopeImage::onUnMount(%db,%pl,%slot)
{
	%pl.sniperCleanUpSched = %pl.schedule(50,sniperLensLoopCleanup,1);
	parent::onUnMount(%db,%pl,%slot);
}
function sniperUnScopeImage::onMount(%db,%pl,%slot)
{
	parent::onMount(%db,%pl,%slot);
}
function sniperUnScopeImage::onUnMount(%db,%pl,%slot)
{
	parent::onUnMount(%db,%pl,%slot);
}

function player::sniperLensLoopStart(%pl)
{
	%pl.sniperLensFlareSet = new simSet();
	%pl.sniperLensLoop();
}
function player::sniperLensLoopCleanup(%pl,%ov)
{
	cancel(%pl.sniperLensSched);
	if(isObject(%pl.sniperLensFlareSet))
	{
		%i = %pl.sniperLensFlareSet.getCount();
		while(%i-->=0)
		{
			%flare = %pl.sniperLensFlareSet.getObject(%i);
			%flare.playThread(1,shrink);
			%flare.delSched = %flare.schedule(500,delete);
		}
		%pl.sniperLensFlareSet.delete();
	}
}
//if(mACos(vectorDot(vectorNormalize(vectorSub(%pos,%start)),%svec)) < $PI/2)
function sAmmo_createSniperRay(%muzPoint,%vec,%end,%scale,%rot)
{
	if(%scale $= "")
		%scale = 9;
	if(%rot $= "")
		%rot = 180;
	%p = new StaticShape() 
	{ 
		dataBlock = swol_bulletTrailStatic;
	};
	%p.setNodeColor("trailB","1 0.8 0 1");
	%p.setNodeColor("trailA","1 1 0.8 1");
	missionCleanup.add(%p);
	%velocity = VectorNormalize(%vec);
	%x = getWord(%velocity,0)/2;
	%y = (getWord(%velocity,1) + 1)/2;
	%z = getWord(%velocity,2)/2;
	%p.setTransform(%muzPoint SPC VectorNormalize(%x SPC %y SPC %z) SPC mDegToRad(180));
	%p.setScale(%scale SPC vectorDist(%muzPoint,%end) SPC %scale);
	return %p;
}
function test(%pl)
{
	%forward = %pl.getEyeVectorHack();
	%up = %pl.getUpVectorHack();
	%shiftV = "0.36 0 0.48";
	%shift = vectorRelativeShift(%forward,%up,%shiftV);
	
	%pos = vectorAdd(%pl.getSlotTransform(%slot),%shift);
	
	%q = SM_Debug.drawPoint(%pos,"1 0 0");
	%q.setScale("0.1 0.1 0.1");
	%q.schedule(500,delete);
	return;
}
function sAmmo_sniperRaycast(%pl,%slot)
{
	%mask = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType;
	%muzPoint = %start = %pl.getMuzzlePoint(%slot);
	%vec = sAmmo_getEyeMod(%pl,%slot);
	%eyeVec = %pl.getEyeVectorHack();
	%scale = 9;
	
	%intialCheck = vectorSub(%pl.getSlotTransform(0),%eyeVec);
	%initial = containerRayCast(%intialCheck,vectorAdd(%intialCheck,vectorScale(%eyeVec,2)),%mask,%pl);
	if(getWord(%initial,0) == 0)
	{
		%scaleFactor = 100;
		%scaleSteps = 7;
		%scaleVec = vectorScale(%vec,%scaleFactor);
		for(%i=0;%i<%scaleSteps;%i++)
		{
			%end = vectorAdd(%start,%scaleVec);
			%ray = containerRayCast(%start,%end,%mask,%pl);
			if(getWord(%ray,0) != 0)
				break;
			%start = %end;
		}
		%start = %muzPoint;
		if((%hit = getWord(%ray,0)) != 0)
			%end = posFromRaycast(%ray);
		else
			%end = vectorAdd(%muzPoint,vectorScale(%vec,%scaleFactor*%scaleSteps));
	}
	else
	{
		%end = posFromRaycast(%initial);
	}
		
	%nvec = vectorNormalize(vectorSub(%end,%muzPoint));
	
	if(%pl.isFirstPerson())
	{
		%forward = %pl.getEyeVectorHack();
		%up = %pl.getUpVectorHack();
		%shiftV = "0.692101 0.399 -0.07684";
		%shift = vectorRelativeShift(%forward,%up,%shiftV);
		
		%muzzleFix = vectorAdd(%pl.getMuzzlePoint(%slot),%shift);
		
		if($Swol_GhostDLL || ($Swol_GhostDLL = isFunction("NetObject","setNetFlag")))
		{
			%p = sAmmo_createSniperRay(%muzzleFix,%vec,%end);
			%p.setNetFlag(6,1);
			%cnt = clientGroup.getCount();
			for(%i=0;%i<%cnt;%i++)
			{
				%cl = clientGroup.getObject(%i);
				if(%pl.client == %cl)
					continue;
				%p.scopeToClient(%cl);
			}
			
			
			%p = sAmmo_createSniperRay(%muzPoint,%vec,%end,18);
			%p.setNetFlag(6,1);
			%p.scopeToClient(%pl.client);
		}
		else
		{
			%p = sAmmo_createSniperRay(%muzPoint,%vec,%end);
		}
	}
	else
	{
		sAmmo_createSniperRay(%muzPoint,%vec,%end);
	}
	if(1 == 2)
	{
		%p = new StaticShape() 
		{ 
			dataBlock = swol_bulletTrailStatic;
		};
		%p.setNodeColor("trailB","1 0.8 0 1");
		%p.setNodeColor("trailA","1 1 0.8 1");
		missionCleanup.add(%p);
		%x = getWord(%nvec,0)/2;
		%y = (getWord(%nvec,1)+1)/2;
		%z = getWord(%nvec,2)/2;
		%p.setTransform(%muzPoint SPC VectorNormalize(%x SPC %y SPC %z) SPC mDegToRad(180));
		%p.setScale(%scale SPC vectorDist(%muzPoint,%end) SPC %scale);
	}
	sniperBulletFly(%pl,%muzPoint,%end,sniperProjectile.bulletWizzRadius);
		
	if(%hit)
	{
		%p = new projectile()
		{
			datablock = sniperProjectile;
			initialPosition = %end;
			sourceObject = %pl;
			client = %pl.client;
		};
		%p.explode();
		%obj = getWord(%hit,0);
		if(minigameCanDamage(%obj,%pl) == 1)
		{
			if(%obj.getType() & $TypeMasks::PlayerObjectType)
			{
				sniperProjectile::onCollision(sniperProjectile,%p,%obj,1,%end);
			}
			if(%obj.getType() & $TypeMasks::VehicleObjectType)
			{
				sniperProjectile::damage(sniperProjectile,%p,%obj,0,%end,0);
			}
		}
		if(isObject(%obj))
		{
			serverPlay3D(bulletImpactEnv @ getRandom(1,5) @ Sound,%end);
		}
	}
}
function sniperBulletFly(%source,%start,%end,%radius)
{	
	%cnt = clientGroup.getCount();
	%svec = vectorNormalize(%sray = vectorSub(%end,%start));
	for(%i=0;%i<%cnt;%i++)
	{
		%cl = clientGroup.getObject(%i);
		if(!isObject(%pl = %cl.player))
			continue;
		%pos = %pl.getHackPosition();
		
		%pdist = vectorDist(%pos,%end);
		
		%distPos = vectorDist(%pos,%start);
		
		%dotCheck = vectorDot(%svec,vectorNormalize(vectorSub(%pos,%start)))+1;
		if(%distPos > 40 && %distPos < 450+(%dotCheck*260))
		{
			%cl.play2D(sniperDistant @ getRandom(1,2) @ Sound);
		}
		if(%distPos < 325)
		{
			%cl.play2D(sniperReverbSound);
		}
			
		%dot = "";
		if(%pdist < sniperProjectile.bulletWizzRadius)
		{
			%sPos = %end;
		}
		else
		{
			%dot = vectorDot(%aray = vectorSub(%pos,%start),%svec);
			if(%dot < 0)
				continue;
			if(%dot/(%slen = vectorLen(%sray)) > 1)
				continue;
				
			%d = vectorLen(vectorCross(%aray,vectorSub(%pos,%end)))/%slen;
			if(%d < %radius)
			{
				%avec = vectorNormalize(%aray);
				%normSq = vectorLen(%svec);
				%normSq *= %normSq;
				%m = vectorDot(%svec,%avec)/%normSq;
				%pray = vectorScale(vectorNormalize(vectorSub(%avec,vectorScale(%svec,%m))),-%d);
				
				%sPos = vectorAdd(%pos,%pray);
			}
		}
		if(%sPos !$= "")
		{			
			%cl.play3D(sniperMiss @ getRandom(1,4) @ Sound,%sPos);
		}
	}
}
function player::sniperLensLoop(%source)
{
	cancel(%source.sniperLensSched);
	%forward = %source.getForwardVector();
	%sEyePos = %source.getEyePoint();
	
	%forward = %source.getEyeVectorHack();
	%up = %source.getUpVectorHack();
	%shiftV = "0.36 0 0.48";
	%shift = vectorRelativeShift(%forward,%up,%shiftV);
	
	%sEyePos = vectorAdd(%source.getSlotTransform(%slot),%shift);
	
	%sEyeVec = %source.getEyeVector();
	
	%mini = %source.client.minigame;
	//if(!%mini)
	//	return;
	%inAng = 0.3;
	%minDist = 120;
	%maxDist = 900;
	%time = getSimTime();
	%cnt = %mini.numMembers;
	%cnt = clientGroup.getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%cl = %mini.member[%i];
		%cl = clientGroup.getObject(%i);
		if(%pl = %cl.player)
		{
			//if(%pl == %source)
			//	continue;
			//if(%cl.getControlObject() == %pl)
			%pos = %cl.getControlObject().getPosition();//%pl.getPosition();
			
			
			%draw = false;
			%exists = isObject(%pl.sniperLensFlareFrom[%source]);
			
			%dist = vectorDist(%sEyePos,%pos);
			
			if(%dist > %minDist && %dist < %maxDist)
			{
				%displacement = vectorSub(%pos,%sEyePos);
				%sHViewAng = mATan(getWord(%sEyeVec,1),getWord(%sEyeVec,0));
				%oHDispAng = mATan(getWord(%displacement,1),getWord(%displacement,0));
				
				%deltaHAng = %sHViewAng-%oHDispAng;
				
				if(%deltaHAng < 0)
					%deltaHAng *= -1;
					
				if(%deltaHAng > $PI)
					%deltaHAng = ($PI*2)-%deltaHAng;
					
				%sVViewAng = getWord(%sEyeVec,2);	
				%oVDispAng = getWord(vectorNormalize(%displacement),2);
				
				%deltaVAng = %sVViewAng-%oVDispAng;
				
				if(%deltaVAng < 0)
					%deltaVAng *= -1;
				
				%pdist = mSqrt(%deltaHAng*%deltaHAng+%deltaVAng*%deltaVAng);
				
				%mask = $TypeMasks::VehicleObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType;
				%hit = containerRayCast(vectorAdd(%pos,"0 0 1"),vectorAdd(vectorAdd(%pos,"0 0 1"),vectorSub(%sEyePos,%pos)),%mask,%pl);
				if(!isObject(getWord(%hit,0)))
				{
					if(%pdist < %inAng)
					{
						if(!%exists)
						{
							%flare = new staticShape()
							{
								datablock = swol_sniperLensStatic;
								source = %sourcer;
								viewer = %pl;
								position = "0 0 0";
								scale = "0.01 0.01 0.01";
							};
							%flare.lastGrow = %time;
							%flare.setNetFlag(6,1);
							%flare.scopeToClient(%cl);
							%flare.playThread(1,grow);
							%pl.sniperLensFlareFrom[%source] = %flare;
							if(!isObject(%pl.sniperRecieveLensFlareSet))
								%pl.sniperRecieveLensFlareSet = new simSet();
							%pl.sniperRecieveLensFlareSet.add(%flare);
							%source.sniperLensFlareSet.add(%flare);
							%exists = true;
						}
						%draw = true;
					}
				}
			}
			if(%exists)
			{
				%flare = %pl.sniperLensFlareFrom[%source];
				%mSize = 6;
				%size = ((%dist/(%maxDist/3))*mCLampF((%cl.getControlCameraFov()/90),0,1))*(mCLampF(1-(%pdist/%inAng),0.4,1))*%mSize;
				if(%size < 2)
				{
					%draw = false;
					%size = 0.01;
				}
				if(%draw)
				{
					if(isEventPending(%flare.delSched))
					{
						cancel(%flare.delSched);
						%flare.playThread(1,grow);
						%flare.lastGrow = %time;
						%flare.isLooping = 0;
					}
					if(!%flare.isLooping && %time-%flare.lastGrow > 500)
					{
						%flare.playThread(1,anim);
						%flare.isLooping = 1;
					}
					if($doBulletDebugs)
					{
						%q = SM_Debug.drawLine(%sEyePos,%pos,"1 1 0");
						%q.schedule(100,delete);
					}
				}
				else
				{
					if(!isEventPending(%flare.delSched))
					{
						%flare.playThread(1,shrink);
						%flare.delSched = %flare.schedule(500,delete);
					}
				}
				%flare.setScale(%size SPC %size SPC %size);
				%pEyeVec = %cl.getControlObject().getEyeVector();
				%u = getWord(%pEyeVec,0);
				%w = getWord(%pEyeVec,1);
				%yaw = mATan(%u,%w)-($PI/2);
				%pitch = 0-mATan(getWord(%pEyeVec,2),mSqrt(%u*%u+%w*%w));
				%rot_xy = -90-%pitch*180/$PI;
				%rot_z = -90-%yaw*180/$pi;
				%rot = eulerToAxis(%rot_xy+90 SPC ((%pdist/%inAng)*180) SPC %rot_z);
				%flare.setTransform(vectorAdd(%sEyePos,vectorNormalize(vectorSub(%pos,%sEyePos))) SPC %rot);
				%flare.setNodeColor("ALL",rgbGradient((%size+1.4)/%mSize,"1 1 1","1 1 0.9") SPC 1);
			}
		}
	}
	%source.sniperLensSched = %source.schedule(64,sniperLensLoop);
}